unit char_sets;

interface

function a2l(const c: Char): Char;
function l2a(const c: Char): Char;
function a2l(const c: Byte): Byte;
function l2a(const c: Byte): Byte;
procedure a2l(var Buf; const sz: LongInt);
procedure l2a(var Buf; const sz: LongInt);
function a2l(s: AnsiString): AnsiString;
function l2a(s: AnsiString): AnsiString;


implementation

const					//00   20   40   60    80   a0   c0   e0
  t_a2l_xor	: Array[0..7] of Byte = ($80, $80, $20, $A0,  $80, $80, $80, $00);
  t_l2a_xor	: Array[0..7] of Byte = ($80, $80, $80, $20,  $80, $80, $A0, $00);

function a2l(const c: Char): Char;
var s: Byte absolute c; d: Byte absolute a2l;
begin d := s xor t_a2l_xor[s shr 5] end;

function l2a(const c: Char): Char;
var s: Byte absolute c; d: Byte absolute l2a;
begin d := s xor t_l2a_xor[s shr 5] end;

function a2l(const c: Byte): Byte;
begin a2l := c xor t_a2l_xor[c shr 5] end;

function l2a(const c: Byte): Byte;
begin l2a := c xor t_l2a_xor[c shr 5] end;

procedure a2l(var Buf; const sz: LongInt);
var p: ^Byte;
begin
  p := @Buf;
  while p < @Buf + sz do begin
    p^ := p^ xor t_a2l_xor[p^ shr 5];
    inc(p);
  end;
end;

procedure l2a(var Buf; const sz: LongInt);
var p: ^Byte;
begin
  p := @Buf;
  while p < @Buf + sz do begin
    p^ := p^ xor t_l2a_xor[p^ shr 5];
    inc(p);
  end;
end;

function a2l(s: AnsiString): AnsiString;
begin
  if s <> '' then a2l(s[1], Length(s));
  Exit(s);
end;

function l2a(s: AnsiString): AnsiString;
begin
  if s <> '' then l2a(s[1], Length(s));
  Exit(s);
end;


end.
