{
      ̣ CRT  ncurses.
         CRT, 
    2006. ,     CRT    ...
}

unit mcrt;

{$mode OBJFPC}

interface

Type
  tTextAttr	= Record c: Byte End; 

Var
  TextAttr	: tTextAttr;

Operator := (const n: Byte) r: tTextAttr;
Operator := (const n: tTextAttr) r: Byte;

Function WindMaxX: LongInt;
Function WindMaxY: LongInt;
Function WindMax : Word;
Function WhereX  : LongInt;
Function WhereY  : LongInt;
Procedure GotoXY(const x, y: LongInt);
Function KeyPressed: Boolean;
Function ReadKey: Char;
Function CursesReadKey: LongInt;
Procedure ClrScr;
Procedure ClrEol;
Procedure CursorOn;
Procedure CursorOff;

Function printw(const fmt: pchar; args: array of const): LongInt; CDecl; External 'curses';
Function addch(const c: LongInt): LongInt; CDecl; External 'curses';
Function endwin: LongInt; CDecl; External; External 'curses';
Function doupdate: LongInt; CDecl; External; External 'curses';


implementation

{$Link msubcrt}
{$LinkLib c}
{$LinkLib curses}

Type
  tWINDOW	= Pointer;
  Bool		= Byte;

Const
  CFALSE	= 0;
  CTRUE		= 1; //  if func() = CTRUE  !!!!!   CFALSE
  ERR		= -1;

{$Include keys.inc}

Var
  stdscr	: tWINDOW;

{ !! -      curses    !! }

// 
Function initscr: tWINDOW; CDecl; External;

//   
Function start_color: LongInt; CDecl; External;
Procedure m_init_pair; CDecl; External;
Procedure m_setattr(const c: Byte); CDecl; External;
Procedure m_setbg(const c: Byte); CDecl; External;

// echo        (  )
Function echo: LongInt; CDecl; External;
Function noecho: LongInt; CDecl; External;

// cbreak     [  raw-mode]
Function cbreak: LongInt; CDecl; External;
Function nocbreak: LongInt; CDecl; External;

//  cbreak,    ^c  
Function raw: LongInt; CDecl; External;
Function noraw: LongInt; CDecl; External;

// qiflush    [??]    ^c  
// (    )
Procedure qiflush; CDecl; External;
Procedure noqiflush; CDecl; External;

//   ESC-  curses (true)    (false)
Function keypad(const wnd: tWINDOW; const bf: Bool): LongInt; CDecl; External;

// getch       (   ERR)
Function nodelay(const wnd: tWINDOW; const bf: Bool): LongInt; CDecl; External;

//     ESC (..    ESC  )
Function notimeout(const wnd: tWINDOW; const bf: Bool): LongInt; CDecl; External;

//     
Procedure m_getyx(const wnd: tWINDOW; var y, x: LongInt); CDecl; External;
//Procedure m_getbegyx(const wnd: tWINDOW; var y, x: LongInt); CDecl; External;
Procedure m_getmaxyx(const wnd: tWINDOW; var y, x: LongInt); CDecl; External;
Function move(const y, x: LongInt): LongInt; CDecl; External;

//  
Function getch: LongInt; CDecl; External;
Function ungetch(const c: LongInt): LongInt; CDecl; External;

//   
Function clear: LongInt; CDecl; External;
Function erase: LongInt; CDecl; External;
Function clrtoeol: LongInt; CDecl; External;

// //__ 
Function curs_set(visibility: LongInt): LongInt; CDecl; External;


Operator := (const n: Byte) r: tTextAttr;
Begin
  r.c := n;
  m_setattr(n);
//  printw('=%x=', [n]);
//  getch;
End;


Operator := (const n: tTextAttr) r: Byte;
Begin
  r := n.c;
End;


Function WindMaxX: LongInt;
var t: LongInt;
Begin m_getmaxyx(stdscr, t, WindMaxX) End;


Function WindMaxY: LongInt;
var t: LongInt;
Begin m_getmaxyx(stdscr, WindMaxY, t) End;


Function WindMax: Word;
var x, y: LongInt;
Begin
  m_getmaxyx(stdscr, y, x); inc(x); inc(y);
  WindMax:=((y and $FF) shl 8) or (x and $FF);
End;

Function WhereX  : LongInt;
var t: LongInt;
Begin m_getyx(stdscr, t, WhereX); inc(WhereX); End;


Function WhereY  : LongInt;
var t: LongInt;
Begin m_getyx(stdscr, WhereY, t); inc(WhereY); End;


Procedure GotoXY(const x, y: LongInt);
begin move(y-1, x-1) end;


Function KeyPressed: Boolean;
var i: LongInt;
begin
  nodelay(stdscr, CTRUE);
//  repeat write(getch, ' . ');   nodelay(stdscr, 1); until false;
  i:=getch;
  KeyPressed:=i<>ERR;
  if KeyPressed then ungetch(i);
end;


Function CursesReadKey: LongInt;
begin
  nodelay(stdscr, CFALSE);
  CursesReadKey := getch;
end;


Function ReadKey: Char;
const p: Char = #0;
var i: LongInt;
begin
  if p = #0 then Begin
    repeat i := CursesReadKey until i >= 0;
    ReadKey:=#0;
//  printw('.%o.', [i]); getch;
    case i of
      KEY_F1	: p:=#59;
      KEY_F2	: p:=#60;
      KEY_F3	: p:=#61;
      KEY_F4	: p:=#62;
      KEY_F5	: p:=#63;
      KEY_F6	: p:=#64;
      KEY_F7	: p:=#65;
      KEY_F8	: p:=#66;
      KEY_F9	: p:=#67;
      KEY_F10	: p:=#68;
      KEY_F11	: p:=#133;
      KEY_F12	: p:=#134;
      KEY_UP	: p:=#72;
      KEY_DOWN	: p:=#80;
      KEY_RIGHT	: p:=#77;
      KEY_LEFT	: p:=#75;
      KEY_NPAGE	: p:=#81;
      KEY_PPAGE	: p:=#73;
      KEY_IC	: p:=#82;
      KEY_SELECT,		// ???
      KEY_DC	: p:=#83;
      KEY_HOME	: p:=#71;
      KEY_END	: p:=#79;

      KEY_BACKSPACE	: Begin p:=#0; ReadKey:=#8; End;
      10		: Begin p:=#0; ReadKey:=#13; End;

      KEY_RESIZE: p:=#255;
    else
      ReadKey:=chr(i and 255);
    end;
  End else Begin
    ReadKey:=p; p:=#0;
  End;
end;


Procedure ClrScr;
Begin
  m_setbg(TextAttr);
//clear;
  erase;
End;


Procedure ClrEol;
Begin clrtoeol End;


Procedure CursorOn;
begin curs_set(1) end;


Procedure CursorOff;
begin curs_set(0) end;


begin
  stdscr:=initscr;
  start_color;
  m_init_pair;
  noecho;
  keypad(stdscr, CTRUE);
  raw;  
end.
