{
       DOS  FreeBSD. ,
     libc   .  ģ  ,
      (   2007-) ,  FindNext
     .     RTL FPC
    ,    .
  ,      .
}

unit MyDos;
// !     !
{$LinkLib c}

interface

const
  DT_UNKNOW	= 0;
  DT_FIFO	= 1;
  DT_CHR	= 2;
  DT_DIR	= 4;
  DT_BLK	= 6;
  DT_REG	= 8;
  DT_LNK	= 10;
  DT_SOCK	= 12;
  DT_WHT	= 14;

  S_IFMT	= &0170000;  // type of file
  S_IFIFO	= &0010000;  // named pipe (fifo)
  S_IFCHR	= &0020000;  // character special
  S_IFDIR	= &0040000;  // directory
  S_IFBLK	= &0060000;  // block special
  S_IFREG	= &0100000;  // regular
  S_IFLNK	= &0120000;  // symbolic link
  S_IFSOCK	= &0140000;  // socket
  S_IFWHT	= &0160000;  // whiteout
  S_ISUID 	= &0004000;  // set user id on execution
  S_ISGID	= &0002000;  // set group id on execution
  S_ISVTX	= &0001000;  // save swapped text even after use
  S_IRUSR	= &0000400;  // read permission, owner
  S_IWUSR	= &0000200;  // write permission, owner
  S_IXUSR	= &0000100;  // execute/search permission, owner

type
  tDir		= Record
    dd_fd	: LongInt;
    dd_loc	: qWord;
    dd_size	: qWord;
    dd_buf	: PChar;
    dd_len	: LongInt;
    dd_seek	: qWord;
    dd_rewind	: qWord;
    dd_flags	: LongInt;
  end;
  pDir		= ^tDir;
  
  tDirEnt	= Record
    fileno	: Cardinal;
    reclen	: Word;
    typ		: Byte; // DT_*
    nlen	: Byte;
    name	: Array[0..255] of Char;
  end;
  pDirEnt	= ^tDirEnt;
  
  tStat		= Record
        dev,                            { inode's device }
        ino        :  cardinal;         { inode's number }
        mode, 				{ inode protection mode }
        nlink	   :  word;             { number of hard links }
        uid,				{ user ID of the file's owner }
        gid,				{ group ID of the file's group }
        dev_t	   :  cardinal;		{ device type }
	atime,                          { time of last access }
	atime_nsec,         		{ nsec of last access }
	mtime,	           		{ time of last data modification }
	mtime_nsec,         		{ nsec of last data modification }
	ctime,            		{ time of last file status change }
	ctime_nsec : longint;      	{ nsec of last file status change }
	size,           		{ file size, in bytes }
	blocks     : Int64;		{ blocks allocated for file }
	blksze,         		{ optimal blocksize for I/O }
	flags,          		{ user defined flags for file }
	filegen    : cardinal;		{ file generation number }
	lspare	   : longint;
	qspare     : array[0..1] of int64;
  end;
  pStat		= ^tStat;

  SearchRec	= Record
    Name	: AnsiString;
    Attr	: Byte;
    Size	: LongInt;

    Dir		: pDir;
    at		: Byte;
    path	: AnsiString;
  end;

Procedure FindFirst(const nm: AnsiString; const Attr: Byte; var SR: SearchRec);
Procedure FindNext(var SR: SearchRec);
Procedure FindClose(var SR: SearchRec);
Procedure Exec(const ex, pr: AnsiString);

var
  DosError	: LongInt;

implementation

function opendir(const name: PChar): pDir; cdecl; external;
function readdir(Dir: pDir): pDirEnt; cdecl; external;
function closedir(Dir: pDir): LongInt; cdecl; external;

function dirname(const nm: PChar): PChar; cdecl; external;
function basename(const nm: PChar): PChar; cdecl; external;

function stat(const nm: PChar; const sb: pStat): LongInt; cdecl; external;
{
Var TheDir : pDir; ADirent : pDirEnt; 

  TheDir:=OpenDir('.'); 
  Repeat 
    ADirent:=ReadDir (TheDir); 
    If ADirent<>Nil then With ADirent^ do begin 
        WriteLn ('fileno   : ',fileno);
        Writeln ('Reclen   : ',reclen); 
	WriteLn ('Nlen     : ',nlen);
	WriteLn ('typ      : ',typ);
        Writeln ('Name     : ',name); 
        end; 
  Until ADirent=Nil; 
  CloseDir (TheDir); 
}
Procedure FindFirst(const nm: AnsiString; const Attr: Byte; var SR: SearchRec);
begin
  SR.path:=dirname(@nm[1]);
  SR.Dir:=OpenDir(@SR.path[1]);
  SR.at:=Attr and 16;
  FindNext(SR);
end;

Procedure FindNext(var SR: SearchRec);
var Ent: pDirEnt; st: tStat; ts: AnsiString; stat_ok: Boolean;
begin
  With SR do if Dir = Nil then DosError := 255 else begin
    Repeat
      Ent := ReadDir(SR.Dir);
      if Ent = Nil then begin DosError := 254; exit end;
      Name := Ent^.Name;
      ts := path + '/' + Name;
      stat_ok := Stat(@ts[1], @st) = 0;
      if st.size > High(Size) then Size := High(Size) else Size := st.size;
    Until ((st.mode and S_IFREG <> 0) or ((at <> 0) and (st.mode and S_IFDIR <> 0))) and stat_ok;
    if st.mode and S_IFDIR <> 0 then Attr:=16 else Attr:=0;
    DosError := 0;
  end;
end;

Procedure FindClose(var SR: SearchRec);
begin
  if SR.Dir<>Nil then CloseDir(SR.Dir);
end;

function fork: Cardinal; cdecl; external;
function execl(const path, arg0, arg, arg_fin: PChar): LongInt; cdecl; external;
function wait(var status: LongInt): Cardinal; cdecl; external;
procedure _exit(status: LongInt); cdecl; external;
procedure perror(const str: PChar); cdecl; external;

Procedure Exec(const ex, pr: AnsiString);
var pid: Cardinal; status: LongInt;
begin
  pid := fork;
  if pid = 0 then begin
    if execl(@(ex[1]), @(ex[1]), @(pr[1]), Nil) = -1 then begin perror('execl'); _exit(99); end;
  end else
    wait(status);
end;

end.
