{
        graph_proc  x11_graph_viewer.c
}
unit uni_graph_viewer;

interface

uses host_os_specific_p, world_formats, char_sets;


//   /  
//  True   
function  GraphOpen: Boolean;

//     w * h   readonly-  512x512 
//     -  Σ,  4-  ,  
// prefer_scale_?      
// comment    ,       
// ikc -    ,  ...
//     (, ),  "" 
//    ,    != Nil
function  GraphExpose(const p: Pointer; const w, h, prefer_scale_w, prefer_scale_h: LongInt; const FName: tAgatName; const comment: PChar; const ikc: tIntKeyComments): tIntKeyCode;

//  
procedure GraphClose;


implementation

{$Link x11_graph_viewer}
{$LinkLib X11}
{$LinkLib Imlib2}

procedure x11_Init(c: LongInt; v: PPChar); CDecl; External;
function  x11_Open: LongInt; CDecl; External;
function  x11_Expose(p: Pointer; w, h, psw, psh: LongInt; comment: PChar; const ikc: tIntKeyComments): LongInt; CDecl; External;
procedure x11_Close; CDecl; External;


function  GraphOpen: Boolean;
begin Exit(x11_Open = 1) end;

procedure GraphClose;
begin x11_Close end;


function  GraphExpose(const p: Pointer; const w, h, prefer_scale_w, prefer_scale_h: LongInt; const FName: tAgatName; const comment: PChar; const ikc: tIntKeyComments): tIntKeyCode;
var cm: AnsiString; n: LongInt; f: Boolean; c: Char;
begin
  if (w = 0) or (h = 0) then Exit( ikcEscape );
  cm := ''; f := False;
  for n := High(FName) downto Low(FName) do begin
    c := a2l(FName[n]);
    if c <> ' ' then f := True;
    if f then cm := c + cm;
  end;
  cm := cm + ': ' + comment;
  exit( x11_Expose(p, w, h, prefer_scale_w, prefer_scale_h, @(cm[1]), ikc) );
end;


(*
var x, y: LongInt; pb: ^Byte; f: Text; pScr: ^tScr;
begin
  pScr := p;
  //  XPM    XV
  pb := p;
  writeln(comment);

  FileMode := 1;
  assign(f, '/tmp/tmp'); rewrite(f);
  writeln(f, '/* XPM */');
  writeln(f, 'static char *XXX[] = {');
  writeln(f, '"  ', w, '  ', h, '  16    1  ",');
  writeln(f, '"0 c #000000",');
  writeln(f, '"1 c #800000",');
  writeln(f, '"2 c #008000",');
  writeln(f, '"3 c #808000",');
  writeln(f, '"4 c #000080",');
  writeln(f, '"5 c #800080",');
  writeln(f, '"6 c #008080",');
  writeln(f, '"7 c #808080",');
  writeln(f, '"8 c #404040",');
  writeln(f, '"9 c #ff0000",');
  writeln(f, '"A c #00ff00",');
  writeln(f, '"B c #ffff00",');
  writeln(f, '"C c #0000ff",');
  writeln(f, '"D c #ff00ff",');
  writeln(f, '"E c #00ffff",');
  writeln(f, '"F c #ffffff",');
  for y := 0 to h - 1 do begin
    write(f, '"');
    for x := 0 to w - 1 do begin
      write(f, HexStr(pScr^[x, y] and $F, 1));
      inc(pb);
    end;
    writeln(f, '",');
  end;
  writeln(f, '};');
  close(f);

  exec('/usr/X11R6/bin/xv', '/tmp/tmp');

  erase(f);
*)

begin
  x11_Init(argc, argv);
end.
