unit char_sets;

interface

function a2l(const c: Char): Char;
function l2a(const c: Char): Char;
function a2l(const c: Byte): Byte;
function l2a(const c: Byte): Byte;
procedure a2l(var Buf; const sz: LongInt);
procedure l2a(var Buf; const sz: LongInt);
function a2l(s: AnsiString): AnsiString;
function l2a(s: AnsiString): AnsiString;


implementation

const
  //  -> win1251: d := s xor t2[s shr 5]; if d >= $C0 then d := t4[d];
  //			      00  20  40  60   80  a0  c0  e0
  t2: Array[0..7] of Byte = ($80,$80,$20,$80, $80,$80,$80,$20);
  t4: Array[$C0..$FF] of Byte = (
    $De,$C0,$C1,$D6,$C4,$C5,$D4,$C3,$D5,$C8,$C9,$Ca,$Cb,$Cc,$Cd,$Ce, // C0
    $Cf,$Df,$D0,$D1,$D2,$D3,$C6,$C2,$Dc,$Db,$C7,$D8,$Dd,$D9,$D7,$Da, // D0
    $Fe,$E0,$E1,$F6,$E4,$E5,$F4,$E3,$F5,$E8,$E9,$Ea,$Eb,$Ec,$Ed,$Ee, // E0
    $Ef,$Ff,$F0,$F1,$F2,$F3,$E6,$E2,$Fc,$Fb,$E7,$F8,$Fd,$F9,$F7,$Fa  // F0
  );

  // win1251 -> : if s >= $C0 then d := t3[s] else d := s xor t1[s shr 5];
  t1: Array[0..7] of Byte = ($80,$80,$80,$20, $80,$80,$00,$00);
  t3: Array[$C0..$FF] of Byte = (
    $e1,$e2,$f7,$e7,$e4,$e5,$f6,$fa,$e9,$ea,$eb,$ec,$ed,$ee,$ef,$f0,
    $f2,$f3,$f4,$f5,$e6,$e8,$e3,$fe,$fb,$fd,$ff,$f9,$f8,$fc,$e0,$f1,
    $61,$62,$77,$67,$64,$65,$76,$7a,$69,$6a,$6b,$6c,$6d,$6e,$6f,$70,
    $72,$73,$74,$75,$66,$68,$63,$7e,$7b,$7d,$7f,$79,$78,$7c,$60,$71
  );


function a2l(const c: Char): Char;
var s: Byte absolute c; d: Byte absolute a2l;
begin d := s xor t2[s shr 5]; if d >= $C0 then d := t4[d]; end;

function l2a(const c: Char): Char;
var s: Byte absolute c; d: Byte absolute l2a;
begin d := s; if d >= $C0 then d := t3[d] else d := d xor t1[d shr 5]; end;

function a2l(const c: Byte): Byte;
begin a2l := c xor t2[c shr 5]; if a2l >= $C0 then a2l := t4[a2l]; end;

function l2a(const c: Byte): Byte;
begin l2a := c; if l2a >= $C0 then l2a := t3[l2a] else l2a := l2a xor t1[l2a shr 5]; end;

procedure a2l(var Buf; const sz: LongInt);
var p: ^Byte;
begin
  p := @Buf;
  while p < @Buf + sz do begin
    p^ := p^ xor t2[p^ shr 5]; if p^ >= $C0 then p^ := t4[p^];
    inc(p);
  end;
end;

procedure l2a(var Buf; const sz: LongInt);
var p: ^Byte;
begin
  p := @Buf;
  while p < @Buf + sz do begin
    if p^ >= $C0 then p^ := t3[p^] else p^ := p^ xor t1[p^ shr 5];
    inc(p);
  end;
end;

function a2l(s: AnsiString): AnsiString;
begin
  if s <> '' then a2l(s[1], Length(s));
  Exit(s);
end;

function l2a(s: AnsiString): AnsiString;
begin
  if s <> '' then l2a(s[1], Length(s));
  Exit(s);
end;


end.
