{
      Windows-.
   , ,     ,    .
}
unit uni_graph_viewer;

interface

uses host_os_specific_p, world_formats, char_sets, subwindows, windows;


//   /  
//  True   
function  GraphOpen: Boolean;

//     w * h   readonly-  512x512 
//     -  Σ,  4-  ,  
// prefer_scale_?      
// comment    ,       
// ikc -    ,  ...
//     (, ),  "" 
//    ,    != Nil
function  GraphExpose(const p: Pointer; const w, h, prefer_scale_w, prefer_scale_h: LongInt; const FName: tAgatName; const comment: PChar; const ikc: tIntKeyComments): tIntKeyCode;

//  
procedure GraphClose;


implementation

const 
  INSTANCE		= $400000;
  className		= 'dos33c2';
  pal			: Array[0..15] of Cardinal = (
    $000000, $00007f, $007f00, $007f7f, $7f0000, $7f007f, $7f7f00, $7f7f7f,
    $404040, $0000ff, $00ff00, $00ffff, $ff0000, $ff00ff, $ffff00, $ffffff
  );

  FontH			= 20;				//  .   

var
  Brushs		: Array[0..15] of HBRUSH;
  WinW, WinH		: LongInt;			//   
  ScaleX, ScaleY	: LongInt;			//      
  GetMaxX, GetMaxY	: LongInt;			//   
  LocalMaxW, LocalMaxH	: LongInt;			//  ,      
  PicRW, PicRH		: LongInt;			//   ,  ޣ Scale*
  PicX0, PicY0		: LongInt;			//    


  WinCl			: WNDCLASS;
  Win			: HWND;
  Event			: MSG;
  dc			: HDC;

  i_p			: Pointer;
  i_ikc			: tIntKeyComments;
  i_comment		: PChar;
  i_w, i_h		: LongInt;
  i_pref_w, i_pref_h	: LongInt;
  FIN			: tIntKeyCode;


procedure calc_scale(const w, h, prefer_scale_w, prefer_scale_h: LongInt);
var sc: LongInt;
begin
{
        ,  
     X  Y
       ,     X:Y = HardProp
}
  if (w * prefer_scale_w < LocalMaxW) and (h * prefer_scale_h < LocalMaxH ) then begin

    // ,  ޣ ,    
    //     
    sc := 1;
    while (w * prefer_scale_w * sc < LocalMaxW) and (h * prefer_scale_h * sc < LocalMaxH) do inc(sc);
    ScaleX := (sc - 1) * prefer_scale_w;
    ScaleY := (sc - 1) * prefer_scale_h;
    PicRW := w * ScaleX;
    PicRH := h * ScaleY;

  end else begin

    //   .   ,      
    //       X  ,    , Y
    ScaleX := LocalMaxW div w;
    PicRW := ScaleX * w;
    ScaleY := Round(ScaleX * prefer_scale_h / prefer_scale_w);
    PicRH := ScaleY * h;

    if PicRH > LocalMaxH then begin

      //      Y   X,       
      ScaleY := LocalMaxH div h;
      PicRH := ScaleY * h;
      ScaleX := Round(ScaleY * prefer_scale_w / prefer_scale_h);
      PicRW := ScaleX * w;

      if PicRW > LocalMaxW then RunError(99)

    end;

  end;
end;



procedure out_text(const ha, va: ShortInt; const msg: PChar);
var Region: RECT; nFormat: UINT;
begin
  if msg = Nil then Exit;
  case ha of
    -1: nFormat := DT_LEFT;
     0: nFormat := DT_CENTER;
    +1: nFormat := DT_RIGHT;
  end;
  case va of
    -1: nFormat := nFormat or DT_TOP;
    +1: nFormat := nFormat or DT_BOTTOM;
  end;
  with Region do begin
    left	:= 0;
    top		:= 0;
    right	:= WinW;
    bottom	:= WinH;
  end;
  // http://www.firststeps.ru/mfc/steps/help/r.php?790
  DrawText(dc, msg, Length(msg), Region, nFormat or DT_NOPREFIX or DT_SINGLELINE);
end;



procedure out_picture;
type
  tScr		= Array[0..511, 0..511] of Byte;

var
  x, y, x_s, y_s: LongInt;
  scr		: ^tScr;

begin
  out_text(-1, -1, i_ikc[ikcLf]);
  out_text( 0, -1, i_ikc[ikcUp]);
  out_text(+1, -1, i_ikc[ikcRg]);

  out_text(-1, +1, i_comment);
  out_text( 0, +1, i_ikc[ikcDn]);
//  out_text(+1, +1, 'F2 - save image');

  SelectObject(dc, CreatePen(PS_NULL, 0, 0));

  scr := i_p;
  for x := 0 to i_w - 1 do begin
    x_s := x * ScaleX + PicX0;
    for y := 0 to i_h - 1 do begin
      y_s := y * ScaleY + PicY0;
      SelectObject(dc, Brushs[ scr^[x, y] and $F ]);
      Rectangle(dc, x_s, y_s, x_s + ScaleX + 1, y_s + ScaleY + 1);
    end;
  end;
end;



function WindowFunc(wnd: HWND; msg: DWord; wparam, lparam: LongInt): LongInt; StdCall;
var PS: PAINTSTRUCT;
begin
  case msg of

    WM_CREATE	: Exit(1);

    WM_KEYDOWN	: begin
      case wparam of
        VK_F3,
        VK_ESCAPE	: if i_ikc[ikcEscape]	<> Nil then FIN := ikcEscape;
        VK_RETURN	: if i_ikc[ikcReturn]	<> Nil then FIN := ikcReturn;
        VK_UP		: if i_ikc[ikcUp]	<> Nil then FIN := ikcUp;
        VK_DOWN		: if i_ikc[ikcDn]	<> Nil then FIN := ikcDn;
        VK_LEFT		: if i_ikc[ikcLf]	<> Nil then FIN := ikcLf;
        VK_RIGHT	: if i_ikc[ikcRg]	<> Nil then FIN := ikcRg;
//	VK_F2, VK_F12	: save_image;
      end;
    end;

    WM_PAINT	: begin
      dc := BeginPaint(wnd, PS);
      out_picture;
      EndPaint(wnd, PS);
    end;

    WM_SIZE	: begin
      WinW := Lo(lparam);
      WinH := Hi(lparam);
      LocalMaxW := WinW;
      LocalMaxH := WinH - FontH * 2;
      calc_scale(i_w, i_h, i_pref_w, i_pref_h);
      PicX0 := (WinW - PicRW) div 2;
      PicY0 := (WinH - PicRH) div 2;

      dc := GetDC(wnd);
      out_picture;
      ReleaseDC(wnd, dc);
    end;

    WM_CLOSE	: begin FIN := ikcEscape; exit(0) end;

    WM_DESTROY	: exit(0);
  end;
  Exit( DefWindowProc(wnd, msg, wparam, lparam) );
end;



function  GraphOpen: Boolean;
begin
  FillChar(WinCl, sizeof(WNDCLASS), 0);
  with WinCl do begin
    style		:= CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc		:= @WindowFunc;
    hInstance		:= INSTANCE;
    hCursor		:= LoadCursor(0, pstr(IDC_ARROW));
    hbrBackground	:= COLOR_WINDOW;
    lpszClassName	:= className;
  end;
  RegisterClass(WinCl);

  exit(True);
end;


function  GraphExpose(const p: Pointer; const w, h, prefer_scale_w, prefer_scale_h: LongInt; const FName: tAgatName; const comment: PChar; const ikc: tIntKeyComments): tIntKeyCode;
var winname: AnsiString; Rec: RECT; Style: DWord;
begin
  i_p		:= p;
  i_w		:= w;
  i_h		:= h;
  i_pref_w	:= prefer_scale_w;
  i_pref_h	:= prefer_scale_h;
  i_ikc		:= ikc;
  i_comment	:= comment;

  FIN		:= ikcR;

  LocalMaxW := GetMaxX - 20;
  LocalMaxH := GetMaxY - 80;
  calc_scale(i_w, i_h, i_pref_w, i_pref_h);
  WinW := PicRW;
  WinH := PicRH + FontH * 2;
  PicX0 := (WinW - PicRW) div 2;
  PicY0 := (WinH - PicRH) div 2;

  Style := WS_OVERLAPPEDWINDOW;
  winname := 'DOS33 Core2: ' + a2l(FName);
  With Rec do begin
    Left	:= (GetMaxX - WinW) div 2;
    Top		:= (GetMaxY - WinH) div 2;
    Right	:= (GetMaxX - WinW) div 2 + WinW;
    Bottom	:= (GetMaxY - WinH) div 2 + WinH;

    AdjustWindowRectEx(@Rec, Style, False, 0);
    Win := CreateWindowEx(WS_EX_TOPMOST, className, @(winname[1]), Style,
      Left, Top, Right - Left + 1, Bottom - Top + 1,
      0, 0, INSTANCE, nil);
  end;

  ShowWindow(Win, SW_SHOWNORMAL);
  UpdateWindow(Win);
  SetActiveWindow(Win); //     -   :((
  BringWindowToTop(Win);

  while GetMessage(Event, 0, 0, 0) and (FIN = ikcR) do begin
    TranslateMessage(Event);
    DispatchMessage(Event);
  end;

  DestroyWindow(Win);
  exit(FIN);
end;


procedure GraphClose;
begin
end;


procedure Init;
var col: LongInt;
begin
  GetMaxX := GetSystemMetrics(SM_CXSCREEN);
  GetMaxY := GetSystemMetrics(SM_CYSCREEN);
  for col := 0 to 15 do Brushs[col] := CreateSolidBrush(pal[col]);
end;


begin
  Init;
end.
