unit char_sets;

interface

function a2l(const c: Char): Char;
function l2a(const c: Char): Char;
function a2l(const c: Byte): Byte;
function l2a(const c: Byte): Byte;
procedure a2l(var Buf; const sz: LongInt);
procedure l2a(var Buf; const sz: LongInt);
function a2l(s: AnsiString): AnsiString;
function l2a(s: AnsiString): AnsiString;


implementation

const
  //  -> cp866: d := s xor t2[s shr 5]; if d > 127 then d := t4[d];
  t2: Array[0..7] of Byte = ($c0,$00,$20,$c0, $80,$80,$80,$60);
  t4: Array[128..223] of Byte = (
    $9e,$80,$81,$96,$84,$85,$94,$83,$95,$88,$89,$8a,$8b,$8c,$8d,$8e,
    $8f,$9f,$90,$91,$92,$93,$86,$82,$9c,$9b,$87,$98,$9d,$99,$97,$9a,
    $ee,$a0,$a1,$e6,$a4,$a5,$e4,$a3,$e5,$a8,$a9,$aa,$ab,$ac,$ad,$ae,
    $af,$ef,$e0,$e1,$e2,$e3,$a6,$a2,$ec,$eb,$a7,$e8,$ed,$e9,$e7,$ea,

    $00,$b3,$c5,$c1,$c2,$b4,$c3,$d9,$1b,$da,$c0,$bf,$0c,$14,$c4,$c8,
    $cd,$ba,$c6,$c9,$bb,$1a,$f2,$f3,$f4,$18,$19,$f5,$bc,$d2,$b5,$d0
  );

  // cp866 -> : if s > 127 then d := t3[s] else d := s xor t1[s shr 5];
  t1: Array[0..3] of Byte = ($80,$80,$80,$20);
  t3: Array[128..255] of Byte = (
    $e1,$e2,$f7,$e7,$e4,$e5,$f6,$fa,$e9,$ea,$eb,$ec,$ed,$ee,$ef,$f0,
    $f2,$f3,$f4,$f5,$e6,$e8,$e3,$fe,$fb,$fd,$ff,$f9,$f8,$fc,$e0,$f1,
    $61,$62,$77,$67,$64,$65,$76,$7a,$69,$6a,$6b,$6c,$6d,$6e,$6f,$70,

    $30,$31,$32,$01,$05,$05,$05,$0b,$0b,$05,$01,$0b,$07,$07,$07,$0b,
    $0a,$03,$04,$06,$0e,$02,$06,$06,$0a,$09,$03,$04,$06,$0e,$02,$03,
    $03,$04,$04,$0a,$0a,$09,$09,$02,$02,$07,$09,$11,$1b,$16,$17,$18,

    $72,$73,$74,$75,$66,$68,$63,$7e,$7b,$7d,$7f,$79,$78,$7c,$60,$71,

    $71,$72,$f7,$77,$74,$75,$f6,$fa,$79,$7a,$7b,$7c,$7d,$7e,$7f,$f0
  );


function a2l(const c: Char): Char;
var s: Byte absolute c; d: Byte absolute a2l;
begin d := s xor t2[s shr 5]; if d > 127 then d := t4[d]; end;

function l2a(const c: Char): Char;
var s: Byte absolute c; d: Byte absolute l2a;
begin if s > 127 then d := t3[s] else d := s xor t1[s shr 5]; end;

function a2l(const c: Byte): Byte;
begin a2l := c xor t2[c shr 5]; if a2l > 127 then a2l := t4[a2l]; end;

function l2a(const c: Byte): Byte;
begin if c > 127 then l2a := t3[c] else l2a := c xor t1[c shr 5]; end;

procedure a2l(var Buf; const sz: LongInt);
var p: ^Byte;
begin
  p := @Buf;
  while p < @Buf + sz do begin
    p^ := p^ xor t2[p^ shr 5]; if p^ > 127 then p^ := t4[p^];
    inc(p);
  end;
end;

procedure l2a(var Buf; const sz: LongInt);
var p: ^Byte;
begin
  p := @Buf;
  while p < @Buf + sz do begin
    if p^ > 127 then p^ := t3[p^] else p^ := p^ xor t1[p^ shr 5];
    inc(p);
  end;
end;

function a2l(s: AnsiString): AnsiString;
begin
  if s <> '' then a2l(s[1], Length(s));
  Exit(s);
end;

function l2a(s: AnsiString): AnsiString;
begin
  if s <> '' then l2a(s[1], Length(s));
  Exit(s);
end;


end.
